Index: /protocol/src/test/java/geniusweb/protocol/session/mopac/MOPACTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/mopac/MOPACTest.java	(revision 21)
+++ /protocol/src/test/java/geniusweb/protocol/session/mopac/MOPACTest.java	(revision 21)
@@ -0,0 +1,140 @@
+package geniusweb.protocol.session.mopac;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.any;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.times;
+import static org.mockito.Mockito.verify;
+import static org.mockito.Mockito.when;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Ignore;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Inform;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import tudelft.utilities.logging.Reporter;
+import tudelft.utilities.repository.NoResourcesNowException;
+
+public class MOPACTest {
+
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId PARTY1ID = new PartyId("party1");
+	private static final PartyId PARTY2ID = new PartyId("party2");
+	private static final PartyId PARTY3ID = new PartyId("party3");
+
+	// don't try to mock settings, all parts are needed and mocking
+	// makes the test unreadable.
+	private final String setstr = "{\"MOPACSettings\":{\"participants\":["
+			+ "{\"party\":{\"partyref\":\"http://party1\",\"parameters\":{}},\"profile\":\"http://profile1\"},"
+			+ "{\"party\":{\"partyref\":\"http://party2\",\"parameters\":{}},\"profile\":\"http://profile2\"},"
+			+ "{\"party\":{\"partyref\":\"http://party3\",\"parameters\":{}},\"profile\":\"http://profile3\"}],"
+			+ "\"deadline\":{\"deadlinetime\":{\"durationms\":100}},\"votingevaluator\":{\"LargestAgreement\":{}}}}";
+
+	private MOPACSettings settings;
+	private Reporter logger = mock(Reporter.class);
+	private MOPAC mopac;
+
+	private final ProtocolToPartyConnFactory factory = mock(
+			ProtocolToPartyConnFactory.class);
+	private final ProtocolToPartyConn conn1 = mock(ProtocolToPartyConn.class),
+			conn2 = mock(ProtocolToPartyConn.class),
+			conn3 = mock(ProtocolToPartyConn.class);
+
+	@Before
+	public void before() throws JsonParseException, JsonMappingException,
+			IOException, NoResourcesNowException {
+		settings = jackson.readValue(setstr, MOPACSettings.class);
+		mopac = settings.getProtocol(logger);
+
+		List connections = Arrays.asList(conn1, conn2, conn3);
+		when(factory.connect(any(List.class))).thenReturn(connections);
+
+		// hack the state.with(connection) stuff simplistically
+
+		when(conn1.getParty()).thenReturn(PARTY1ID);
+		when(conn2.getParty()).thenReturn(PARTY2ID);
+		when(conn3.getParty()).thenReturn(PARTY3ID);
+	}
+
+	@Test
+	public void testSmoke() {
+	}
+
+	@Test
+	public void testGetDescr() {
+		assertNotNull(mopac.getDescription());
+	}
+
+	@Test
+	public void testInitialState() {
+		MOPACState state = mopac.getState();
+		assertEquals(settings, state.getSettings());
+		assertTrue(state.getActions().isEmpty());
+	}
+
+	@Test
+	public void testProtocol() {
+		assertEquals("MOPAC", mopac.getRef().getURI().getPath());
+	}
+
+	@Ignore
+	@Test
+	public void testWorkingCheckDeadline()
+			throws IOException, NoResourcesNowException, InterruptedException {
+
+		mopac.start(factory);
+
+		System.out.println(mopac.getState());
+
+		// we have deadline in 100ms so check
+		Thread.sleep(200);
+
+		System.out.println(mopac.getState());
+		assertTrue(mopac.getState().isFinal(System.currentTimeMillis()));
+	}
+
+	@Ignore
+	@Test
+	public void testSubscribedToConnections() {
+		mopac.start(factory);
+		verify(conn1, times(1)).addListener(any());
+		verify(conn2, times(1)).addListener(any());
+		verify(conn3, times(1)).addListener(any());
+	}
+
+	@Ignore
+	@Test
+	public void testActionIsBroadcast()
+			throws IOException, NoResourcesNowException, InterruptedException {
+
+		mopac.start(factory);
+		Action offer = mock(Offer.class);
+		mopac.actionRequest(conn1, offer, 1l);
+
+		// 1 time for YourTurn, one time for ActionDone.
+		// but filtering ActionDone here (instead of Action) does not work,
+		// maybe bug in Mockito?
+		verify(conn1, times(2)).send(any(Inform.class));
+	}
+
+	@Test
+	public void testAgreementTerminates() {
+
+	}
+}
Index: /protocol/src/test/java/geniusweb/protocol/session/mopac/PartyStatesTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/mopac/PartyStatesTest.java	(revision 21)
+++ /protocol/src/test/java/geniusweb/protocol/session/mopac/PartyStatesTest.java	(revision 21)
@@ -0,0 +1,57 @@
+package geniusweb.protocol.session.mopac;
+
+import static org.junit.Assert.assertEquals;
+
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Map;
+
+import org.junit.Test;
+
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.protocol.ProtocolException;
+
+public class PartyStatesTest {
+
+	private final PartyId party1 = new PartyId("party1");
+	private final PartyId party2 = new PartyId("party2");
+	private final PartyId party3 = new PartyId("party3");
+
+	private final Map<PartyId, Integer> powers = new HashMap<>();
+	private final PartyStates states;
+
+	public PartyStatesTest() {
+		powers.put(party1, 2);
+		powers.put(party2, 3);
+		powers.put(party3, 3);
+		states = new PartyStates(powers);
+	}
+
+	@Test
+	public void testBasics() {
+		assertEquals(powers.keySet(), states.getNegotiatingParties());
+		assertEquals(powers.keySet(), states.getNotYetActed());
+		assertEquals(0, states.getExceptions().size());
+	}
+
+	@Test
+	public void testException() {
+		PartyStates newstates = states
+				.with(new ProtocolException("bla", party1));
+		assertEquals(new Agreements(), newstates.getAgreements());
+		assertEquals(powers.keySet(), states.getNegotiatingParties());
+		assertEquals(new HashSet<>(Arrays.asList(party2, party3)),
+				newstates.getNotYetActed());
+	}
+
+	@Test
+	public void testFinish() {
+		PartyStates newstates = states.finish();
+		assertEquals(new Agreements(), newstates.getAgreements());
+		assertEquals(powers.keySet(), states.getNegotiatingParties());
+		assertEquals(Collections.emptySet(), newstates.getNotYetActed());
+	}
+}
Index: /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OfferPhaseTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OfferPhaseTest.java	(revision 21)
+++ /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OfferPhaseTest.java	(revision 21)
@@ -0,0 +1,67 @@
+package geniusweb.protocol.session.mopac.phase;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Mockito.mock;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.Map;
+
+import org.junit.Test;
+
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Votes;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.mopac.PartyStates;
+import geniusweb.voting.VotingEvaluator;
+
+/**
+ * We also test defaultPhase here.
+ */
+public class OfferPhaseTest {
+
+	private final PartyId party1 = new PartyId("party1");
+	private final PartyId party2 = new PartyId("party2");
+	private final PartyId party3 = new PartyId("party3");
+
+	private final Map<PartyId, Integer> powers = new HashMap<>();
+	private final PartyStates states;
+	private final VotingEvaluator evaluator = mock(VotingEvaluator.class);
+	private final OfferPhase phase;
+
+	public OfferPhaseTest() {
+		powers.put(party1, 2);
+		powers.put(party2, 3);
+		powers.put(party3, 3);
+		states = new PartyStates(powers);
+		phase = new OfferPhase(null, states, 10l, evaluator);
+	}
+
+	@Test
+	public void isInitFinalTest() {
+		assertFalse(phase.isFinal(1l));
+		assertTrue(phase.isFinal(10l));
+	}
+
+	@Test(expected = ProtocolException.class)
+	public void checkIncorrectActorTest() throws ProtocolException {
+		phase.checkAction(party1, new EndNegotiation(party2), 1);
+	}
+
+	@Test(expected = ProtocolException.class)
+	public void checkNotAllowedActionTest() throws ProtocolException {
+		phase.checkAction(party1, new Votes(party2, Collections.emptyList()),
+				1);
+	}
+
+	@Test
+	public void testException() {
+		OfferPhase newphase = phase.with(new ProtocolException("bla", party1));
+		assertEquals(10l, newphase.getDeadline());
+		assertEquals(0l, phase.getPartyStates().getActions().size());
+	}
+
+}
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java	(revision 20)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java	(revision 21)
@@ -19,4 +19,5 @@
 import geniusweb.deadline.DeadlineRounds;
 import geniusweb.deadline.DeadlineTime;
+import geniusweb.protocol.session.OnePartyTeam;
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.references.Parameters;
@@ -29,10 +30,10 @@
 public class SAOPSettingsTest extends GeneralTests<SAOPSettings> {
 
-	private SaopPartyWithProfile partyprof1 = mock(SaopPartyWithProfile.class);
-	private SaopPartyWithProfile partyprof2 = mock(SaopPartyWithProfile.class);
-	private SaopPartyWithProfile partyprof3 = mock(SaopPartyWithProfile.class);
-	private List<SaopPartyWithProfile> participants2 = Arrays.asList(partyprof1,
+	private OnePartyTeam partyprof1 = mock(OnePartyTeam.class);
+	private OnePartyTeam partyprof2 = mock(OnePartyTeam.class);
+	private OnePartyTeam partyprof3 = mock(OnePartyTeam.class);
+	private List<OnePartyTeam> participants2 = Arrays.asList(partyprof1,
 			partyprof2);
-	private List<SaopPartyWithProfile> participants3 = Arrays.asList(partyprof1,
+	private List<OnePartyTeam> participants3 = Arrays.asList(partyprof1,
 			partyprof2, partyprof3);
 
@@ -66,9 +67,7 @@
 				new PartyRef("http://party2"), new Parameters());
 		ProfileRef profile2 = new ProfileRef("http://profile2");
-		SaopPartyWithProfile partywithprof1 = new SaopPartyWithProfile(party1,
-				profile1);
-		SaopPartyWithProfile partywithprof2 = new SaopPartyWithProfile(party2,
-				profile2);
-		List<SaopPartyWithProfile> participants = Arrays.asList(partywithprof1,
+		OnePartyTeam partywithprof1 = new OnePartyTeam(party1, profile1);
+		OnePartyTeam partywithprof2 = new OnePartyTeam(party2, profile2);
+		List<OnePartyTeam> participants = Arrays.asList(partywithprof1,
 				partywithprof2);
 
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 20)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 21)
@@ -176,5 +176,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertNull(state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 	}
 
@@ -184,5 +184,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertNull(state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 	}
 
@@ -192,5 +192,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertNull(state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 	}
 
@@ -200,5 +200,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertEquals(bid1, state.getAgreement());
+		assertEquals(bid1, state.getAgreements().getMap().get(party1));
 		assertTrue(state.isFinal(NOW));
 	}
@@ -209,5 +209,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertEquals(null, state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 	}
 
@@ -217,5 +217,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertEquals(null, state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 	}
 
@@ -246,5 +246,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertEquals(null, state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 		assertEquals(null, state.getError());
 		assertTrue(state.isFinal(NOW));
@@ -255,5 +255,6 @@
 	public void isProtocolErrorFinal() {
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
-				settings, null, new ProtocolException("test error", "test"));
+				settings, null,
+				new ProtocolException("test error", new PartyId("test")));
 		assertTrue(state.isFinal(NOW));
 		assertNotNull(state.getError());
@@ -309,5 +310,5 @@
 		assertTrue(state.isFinal(NOW));
 		assertNull(state.getError());
-		assertEquals(bid1, state.getAgreement());
+		assertEquals(bid1, state.getAgreements().getMap().get(party1));
 
 	}
@@ -325,5 +326,5 @@
 		assertTrue(state.isFinal(NOW));
 		assertNull(state.getError());
-		assertEquals(bid2, state.getAgreement());
+		assertEquals(bid2, state.getAgreements().getMap().get(party1));
 
 	}
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 20)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 21)
@@ -34,8 +34,8 @@
 import geniusweb.events.CurrentState;
 import geniusweb.events.ProtocolEvent;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.progress.Progress;
 import geniusweb.protocol.ProtocolException;
@@ -43,4 +43,5 @@
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.session.OnePartyTeam;
 import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
 import geniusweb.references.Parameters;
@@ -75,6 +76,6 @@
 	private final PartyRef party2ref = mock(PartyRef.class);
 	private final SAOPSettings settings = mock(SAOPSettings.class);
-	private final SaopPartyWithProfile team1 = mock(SaopPartyWithProfile.class);
-	private final SaopPartyWithProfile team2 = mock(SaopPartyWithProfile.class);
+	private final OnePartyTeam team1 = mock(OnePartyTeam.class);
+	private final OnePartyTeam team2 = mock(OnePartyTeam.class);
 	private SAOP saop;
 	private ProtocolToPartyConnFactory factory;
@@ -82,5 +83,5 @@
 	private ProtocolToPartyConn conn1 = mock(ProtocolToPartyConn.class),
 			conn2 = mock(ProtocolToPartyConn.class);
-	private Map<PartyId, SaopPartyWithProfile> partyprofiles;
+	private Map<PartyId, OnePartyTeam> partyprofiles;
 	private Progress progress = mock(Progress.class);
 	private ProfileRef profile1;
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java	(revision 20)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java	(revision 21)
@@ -17,4 +17,5 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
+import geniusweb.protocol.session.OnePartyTeam;
 import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
 import geniusweb.references.Parameters;
@@ -24,11 +25,10 @@
 import tudelft.utilities.junit.GeneralTests;
 
-public class SaopPartyWithProfileTest
-		extends GeneralTests<SaopPartyWithProfile> {
+public class SaopPartyWithProfileTest extends GeneralTests<OnePartyTeam> {
 
 	private PartyRef party1, party1a, party2, party3;
 	private ProfileRef profile1, profile2;
-	private SaopPartyWithProfile partyprof1, partyprof1a, partyprof2,
-			partyprof3, partyprof4;
+	private OnePartyTeam partyprof1, partyprof1a, partyprof2, partyprof3,
+			partyprof4;
 	private final String serialized = "{\"party\":{\"partyref\":\"ws:party1\",\"parameters\":{}},\"profile\":\"ws:profile1\"}";
 
@@ -54,14 +54,14 @@
 				settings1);
 
-		partyprof1 = new SaopPartyWithProfile(party1withparams1, profile1);
-		partyprof1a = new SaopPartyWithProfile(party1withparams1, profile1);
-		partyprof2 = new SaopPartyWithProfile(party2withparams1, profile1);
-		partyprof3 = new SaopPartyWithProfile(party1withparams1, profile2);
-		partyprof4 = new SaopPartyWithProfile(party1withparams2, profile1);
+		partyprof1 = new OnePartyTeam(party1withparams1, profile1);
+		partyprof1a = new OnePartyTeam(party1withparams1, profile1);
+		partyprof2 = new OnePartyTeam(party2withparams1, profile1);
+		partyprof3 = new OnePartyTeam(party1withparams1, profile2);
+		partyprof4 = new OnePartyTeam(party1withparams2, profile1);
 
 	}
 
 	@Override
-	public List<List<SaopPartyWithProfile>> getGeneralTestData() {
+	public List<List<OnePartyTeam>> getGeneralTestData() {
 		return Arrays.asList(Arrays.asList(partyprof1, partyprof1a),
 				Arrays.asList(partyprof2), Arrays.asList(partyprof3),
@@ -84,5 +84,5 @@
 	@Test(expected = IllegalArgumentException.class)
 	public void nullTest() throws URISyntaxException {
-		new SaopPartyWithProfile((PartyWithParameters) null, (ProfileRef) null);
+		new OnePartyTeam((PartyWithParameters) null, (ProfileRef) null);
 	}
 
@@ -103,5 +103,5 @@
 		// and therfore can not serialize as TeamOfPartiesAndProfiles
 		TeamOfPartiesAndProfiles p = jackson.readValue(serialized,
-				SaopPartyWithProfile.class);
+				OnePartyTeam.class);
 		System.out.println(p);
 		assertEquals(partyprof1, p);
Index: /protocol/src/test/java/geniusweb/protocol/session/shaop/SHAOPStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/shaop/SHAOPStateTest.java	(revision 20)
+++ /protocol/src/test/java/geniusweb/protocol/session/shaop/SHAOPStateTest.java	(revision 21)
@@ -4,5 +4,4 @@
 import static org.junit.Assert.assertFalse;
 import static org.junit.Assert.assertNotNull;
-import static org.junit.Assert.assertNull;
 import static org.junit.Assert.assertTrue;
 import static org.mockito.Mockito.mock;
@@ -194,5 +193,5 @@
 		SHAOPState state = new SHAOPState(actions, connections3, progressrounds,
 				settings, null, 0, null, null);
-		assertNull(state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 	}
 
@@ -201,6 +200,6 @@
 		List<Action> actions = Arrays.asList(offer1, accept2);
 		SHAOPState state = new SHAOPState(actions, connections4, progressrounds,
-				settings, null, 0, null, null);
-		assertNotNull(state.getAgreement());
+				settings, null, 0, partynrs, null);
+		assertFalse(state.getAgreements().getMap().isEmpty());
 		assertTrue(state.isFinal(NOW));
 	}
@@ -211,5 +210,5 @@
 		SHAOPState state = new SHAOPState(actions, connections3, progressrounds,
 				settings, null, 0, null, null);
-		assertNull(state.getAgreement());
+		assert (state.getAgreements().getMap().isEmpty());
 	}
 
@@ -219,5 +218,5 @@
 		SHAOPState state = new SHAOPState(actions, connections3, progressrounds,
 				settings, null, 0, null, null);
-		assertEquals(null, state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 	}
 
@@ -245,5 +244,5 @@
 		SHAOPState state = new SHAOPState(actions, connections3, progressrounds,
 				settings, null, 0, null, null);
-		assertEquals(null, state.getAgreement());
+		assertTrue(state.getAgreements().getMap().isEmpty());
 		assertEquals(null, state.getError());
 		assertTrue(state.isFinal(NOW));
@@ -254,6 +253,7 @@
 	public void isProtocolErrorFinal() {
 		SHAOPState state = new SHAOPState(actions, connections3, progressrounds,
-				settings, new ProtocolException("test error", "test"), 0, null,
-				null);
+				settings,
+				new ProtocolException("test error", new PartyId("test")), 0,
+				null, null);
 		assertTrue(state.isFinal(NOW));
 		assertNotNull(state.getError());
Index: /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocolTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocolTest.java	(revision 20)
+++ /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocolTest.java	(revision 21)
@@ -20,5 +20,5 @@
 
 import geniusweb.events.ProtocolEvent;
-import geniusweb.issuevalue.Bid;
+import geniusweb.inform.Agreements;
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.NegoState;
@@ -44,5 +44,5 @@
 	private final SessionSettings settings = mock(SessionSettings.class);
 	private final SessionState finalsessionstate = mock(SessionState.class);
-	private Bid agreement = mock(Bid.class);
+	private Agreements agreement = mock(Agreements.class);
 	private final long NOW = 1000;
 	private SessionResult finalstate = mock(SessionResult.class);
@@ -53,7 +53,7 @@
 		when(finalsessionstate.isFinal(anyLong())).thenReturn(true);
 		when(finalsessionstate.getSettings()).thenReturn(settings);
-		when(finalsessionstate.getAgreement()).thenReturn(agreement);
+		when(finalsessionstate.getAgreements()).thenReturn(agreement);
 		when(finalsessionstate.getResult()).thenReturn(finalstate);
-		when(finalstate.getAgreement()).thenReturn(agreement);
+		when(finalstate.getAgreements()).thenReturn(agreement);
 		when(state.with(any())).thenReturn(newstate);
 	}
@@ -112,5 +112,5 @@
 				.forClass(SessionResult.class);
 		verify(state, times(1)).with(argument.capture());
-		assertEquals(agreement, argument.getValue().getAgreement());
+		assertEquals(agreement, argument.getValue().getAgreements());
 		assertNull(argument.getValue().getError());
 	}
Index: /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsStateTest.java	(revision 20)
+++ /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsStateTest.java	(revision 21)
@@ -88,5 +88,4 @@
 		AllPermutationsState state1 = state.with(result);
 
-		assertEquals(null, state1.getError());
 		assertEquals(8, state1.getResults().size());
 		assertEquals(toursettings, state1.getSettings());
Index: /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java
===================================================================
--- /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java	(revision 20)
+++ /pythonadapter/src/main/java/geniusweb/pythonadapter/PythonPartyAdapter.java	(revision 21)
@@ -8,8 +8,8 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.Inform;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
 import geniusweb.party.Party;
-import geniusweb.party.inform.Inform;
 import tudelft.utilities.listener.Listener;
 
Index: /references/src/test/java/geniusweb/references/ProtocolRefTest.java
===================================================================
--- /references/src/test/java/geniusweb/references/ProtocolRefTest.java	(revision 20)
+++ /references/src/test/java/geniusweb/references/ProtocolRefTest.java	(revision 21)
@@ -17,5 +17,4 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
-import geniusweb.references.ProtocolRef;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -58,4 +57,11 @@
 
 	@Test
+	public void testSaop() {
+		ProtocolRef saop = new ProtocolRef("SAOP");
+		System.out.println(saop.getURI());
+		assertEquals("SAOP", saop.getURI().getPath());
+	}
+
+	@Test
 	public void testSerialize() throws JsonProcessingException {
 		ObjectMapper jackson = new ObjectMapper();
Index: /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 20)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 21)
@@ -3,4 +3,5 @@
 import java.io.IOException;
 import java.net.URI;
+import java.util.concurrent.ArrayBlockingQueue;
 
 import geniusweb.connection.ConnectionEnd;
@@ -22,4 +23,6 @@
 	// to be initialized
 	private Listener<OUT> handler = null;
+	private Thread handlerThread;
+	private ArrayBlockingQueue<OUT> messages = new ArrayBlockingQueue<OUT>(4);
 
 	/**
@@ -33,4 +36,5 @@
 		this.reference = reference;
 		this.uri = uri;
+
 	}
 
@@ -47,4 +51,20 @@
 		}
 		this.handler = newhandler;
+
+		handlerThread = new Thread(new Runnable() {
+
+			@Override
+			public void run() {
+				try {
+					while (true) {
+						handler.notifyChange(messages.take());
+					}
+				} catch (InterruptedException e) {
+					System.out.println("connection handler interrupted");
+				}
+			}
+		});
+
+		handlerThread.start();
 	}
 
@@ -55,5 +75,9 @@
 					"BasicConnection has not been initialized");
 		}
-		handler.notifyChange(data);
+		try {
+			messages.put(data);
+		} catch (InterruptedException e) {
+			throw new IOException(e);
+		}
 	}
 
@@ -70,5 +94,7 @@
 	@Override
 	public void close() {
-
+		handlerThread.interrupt();
+		handlerThread = null;
+		handler = null;
 	}
 
Index: /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 20)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 21)
@@ -11,6 +11,6 @@
 import geniusweb.actions.Action;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.Inform;
 import geniusweb.party.Party;
-import geniusweb.party.inform.Inform;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
@@ -22,6 +22,4 @@
  * <code>classpath:org/my/package/class</code>
  * 
- * 
- *
  */
 public class ClassPathConnectionFactory implements ProtocolToPartyConnFactory {
Index: /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java
===================================================================
--- /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 20)
+++ /simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 21)
@@ -29,8 +29,19 @@
 	private final ProtocolToPartyConnFactory connectionfactory;
 	protected final Reporter log;
+	private boolean properlyStopped = false;
 	private final static ObjectMapper jackson = new ObjectMapper();
+	private final int LOOPTIME = 200;// ms
+	private long maxruntime;
 
+	/**
+	 * 
+	 * @param settings
+	 * @param connectionfactory
+	 * @param logger
+	 * @param maxruntime        limit in millisecs. Ignored if 0
+	 */
 	public NegoRunner(NegoSettings settings,
-			ProtocolToPartyConnFactory connectionfactory, Reporter logger) {
+			ProtocolToPartyConnFactory connectionfactory, Reporter logger,
+			long maxruntime) {
 		if (settings == null || connectionfactory == null) {
 			throw new NullPointerException("Arguments must be not null");
@@ -40,4 +51,9 @@
 		this.protocol = settings.getProtocol(log);
 		this.connectionfactory = connectionfactory;
+		this.maxruntime = maxruntime;
+	}
+
+	public boolean isProperlyStopped() {
+		return properlyStopped;
 	}
 
@@ -46,4 +62,14 @@
 		protocol.addListener(evt -> handle(evt));
 		protocol.start(connectionfactory);
+		long remainingtime = maxruntime;
+		while (!properlyStopped && (maxruntime == 0 || remainingtime > 0)) {
+			try {
+				Thread.sleep(LOOPTIME);
+				remainingtime -= LOOPTIME;
+			} catch (InterruptedException e) {
+				e.printStackTrace();
+			}
+		}
+		System.out.println("end run");
 	}
 
@@ -56,7 +82,6 @@
 
 	protected void stop() {
-		Level level = protocol.getState().getError() == null ? Level.INFO
-				: Level.WARNING;
-		logFinal(level, protocol.getState());
+		logFinal(Level.INFO, protocol.getState());
+		properlyStopped = true;
 	}
 
@@ -88,10 +113,10 @@
 
 		NegoRunner runner = new NegoRunner(settings,
-				new ClassPathConnectionFactory(), new StdOutReporter());
+				new ClassPathConnectionFactory(), new StdOutReporter(), 0);
 		runner.run();
 	}
 
 	private static void showusage() {
-		System.err.println("GeniusWeb stand-alone runner. ");
+		System.err.println("GeniusWeb stand-alone runner.");
 		System.err.println("first argument should be <settings.json>.");
 		System.err.println(
@@ -100,4 +125,11 @@
 				"See the settings.json example file and the GeniusWeb wiki pages. ");
 
+	}
+
+	/**
+	 * @return protocol that runs/ran the session.
+	 */
+	public NegoProtocol getProtocol() {
+		return protocol;
 	}
 }
Index: /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java
===================================================================
--- /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 20)
+++ /simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 21)
@@ -11,7 +11,6 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.ConnectionEnd;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 import geniusweb.references.PartyRef;
-import geniusweb.simplerunner.ClassPathConnectionFactory;
 
 public class ClassPathConnectionFactoryTest {
